from PyQt4 import QtCore, QtGui

class CloseButton(QtGui.QPushButton):
  def __init__(self, parent):
    QtGui.QPushButton.__init__(self, QtGui.QIcon("core/icons/cancel.png"), "", parent)
    self.setFocusPolicy(QtCore.Qt.NoFocus)
    self.setFlat(1)

    QtCore.QObject.connect(self, QtCore.SIGNAL("clicked()"), self.closeCurrentWidget)

  def closeCurrentWidget(self):
    self.parent().parent().closeCurrentWidget()
