from PyQt4 import QtCore

from Xlib.display import Display
from Xlib import X, XK, Xatom

class WindowCatcher(QtCore.QThread):
  def __init__(self, desktop):
    QtCore.QThread.__init__(self)
    self.desktop=desktop

  def run(self):
    dpy = Display()
    root = dpy.screen().root

    root.change_attributes(event_mask=X.SubstructureNotifyMask)

    while True:
      ev=root.display.next_event()
      if ev.type==X.MapNotify:
        if ev.window.get_attributes()._data['override_redirect']==0:
          if ev.window.query_tree()._data['parent']==root:
            id=ev.window.id
            if id!=self.desktop.winId():
              name=ev.window.get_wm_name()
              # TODO see if Qt.QueuedConnection would be ok
              e=QtCore.QEvent(self.desktop.NEW_XWINDOW_EVENT)
              e.id=id
              e.name=name
              QtCore.QCoreApplication.postEvent(self.desktop, e)
