from PyQt4 import QtCore, QtGui, uic

from . import __path__
from core.auimd_widget import *

(Ui_Keyboard, BaseClass) = uic.loadUiType(__path__[0]+"/ui/keyboard.ui")

class Keyboard(BaseClass, Ui_Keyboard):
  def __init__(self, parent, init_value="", secret=False):
    BaseClass.__init__(self, parent)

    self.setupUi(self)
    self.display.setText(init_value)
    if secret:
      self.display.setEchoMode(QtGui.QLineEdit.PasswordEchoOnEdit)
  
  def onButtonClicked(self):
    s=self.sender()
    if s is self.bt_validate:
      self.emit(QtCore.SIGNAL("validated"), self.display.text())
    elif s is self.bt_bs:
      self.display.setText(self.display.text()[:-1])
    else:
      self.display.setText(self.display.text()+s.text())
